#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  clrDeepSkyBlue
#property indicator_width1  2

//
//
//
//
//

extern int                MaLength     =  20;
extern ENUM_APPLIED_PRICE AppliedPrice = PRICE_CLOSE;
extern int                Shift        = 0;

double MaBuffer[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,MaBuffer); SetIndexShift(0,Shift);
   return(0);
}
int deinit()
{
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = Bars-counted_bars;
         
   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--) MaBuffer[i] = iMcma(iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i),MaLength,i);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workMcma[][2];
double iMcma(double price, double period, int r, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workMcma,0)!= Bars) ArrayResize(workMcma,Bars); r = Bars-r-1; instanceNo*=2;

   //
   //
   //
   //
   //
      
   workMcma[r][instanceNo+0] = price;
   workMcma[r][instanceNo+1] = price;
   double alpha = 2.0 / (1.0+period);
   if (r>0)
      {
          workMcma[r][instanceNo+0] = workMcma[r-1][instanceNo+0]+alpha*(price                    -workMcma[r-1][instanceNo+0]);
          workMcma[r][instanceNo+1] = workMcma[r-1][instanceNo+1]+alpha*(workMcma[r][instanceNo+0]-workMcma[r-1][instanceNo+1]);
      }          
   return(((2-alpha)*workMcma[r][instanceNo+0]-workMcma[r][instanceNo+1])/(1-alpha));
}
